@use 'sass:map';
@use '@angular/material' as mat;
@use '../colors';

// component mixins
@use 'top-bar-theme' as top-bar;
@use 'button';
@use 'list-theme' as list;
@use 'menu-label';
@use 'menu';
@use 'standard-hover';
@use 'highlight';
@use 'logo';
@use 'disabled-text';
@use 'form-theme' as form;
@use 'expansion-theme' as expansion;
@use 'missing-selection-theme' as missing;
@use 'slides';

@mixin set-colors($theme) {
  // config
  $config: mat.get-color-config($theme);
  // palette colors
  $primary-palette: map.get($config, 'primary');
  $accent-palette: map.get($config, 'accent');
  $warn-palette: map.get($config, 'warn');

  // palette fore- and background
  $foreground-palette: map.get($config, foreground);
  $background-palette: map.get($config, background);

  // primary colors - read the hues from the primary color palette
  $primary-color: mat.get-color-from-palette($primary-palette); // default should be 500
  $primary-color-100: mat.get-color-from-palette($primary-palette, 100);
  $primary-color-200: mat.get-color-from-palette($primary-palette, 200);
  $primary-color-400: mat.get-color-from-palette($primary-palette, 400);

  // primary contrast color
  $primary-contrast-color: mat.get-color-from-palette($primary-palette, default-contrast);
  $background-contrast-color: mat.get-color-from-palette($background-palette, default-contrast);

  // warn colors
  $warn-color-500: mat.get-color-from-palette($warn-palette, 500);
  $warn-color-A700: mat.get-color-from-palette($warn-palette, A700);

  // dark gray colors
  $dark-gray-color-200: mat.get-color-from-palette(colors.$emp-dark-gray, 200);
  $dark-gray-color-500: mat.get-color-from-palette(colors.$emp-dark-gray, 500);

  // text
  $text-color: mat.get-color-from-palette($foreground-palette, text);
  $disabled-text-color: mat.get-color-from-palette($foreground-palette, disabled-text);

  $light-theme-border-color: mat.get-color-from-palette(mat.$light-theme-foreground-palette, divider);
  $light-theme-color: mat.get-color-from-palette(mat.$light-theme-foreground-palette, text);
  $light-theme-background-color: mat.get-color-from-palette(mat.$light-theme-background-palette, background);

  $single-list-item-background-color: mat.get-color-from-palette($background-palette, hover, 0.22);

  $hover-background-color: mat.get-color-from-palette($background-palette, hover, 0.62);
  $examination-border: 1px solid $hover-background-color;
  $background-raised-button-color: mat.get-color-from-palette($background-palette, raised-button);

  @include top-bar.set-border-color($light-theme-border-color);
  @include top-bar.set-top-bar-theme($light-theme-color, $light-theme-background-color);

  @include button.set-button-list-hover($primary-color-100, $dark-gray-color-500, $dark-gray-color-200);

  @include list.set-background-color($single-list-item-background-color);

  @include menu-label.set-primary-background-color($primary-contrast-color, $primary-color);

  @include menu.set-border-box-shadow($primary-color);
  @include menu.set-menu-item-panel-color($primary-color-100, $background-raised-button-color);
  @include menu.set-menu-footer-color($primary-color-100);

  @include standard-hover.set-hover-color($primary-color-200, $primary-color-400, $dark-gray-color-500);

  @include highlight.set-highlight-background($dark-gray-color-500, $hover-background-color);
  @include highlight.set-highlight-expansion-button-background($dark-gray-color-500, $dark-gray-color-500);
  @include highlight.set-highlight-examination-background($dark-gray-color-500, $text-color, $examination-border);

  @include logo.set-logo-background($text-color);

  @include disabled-text.set-disabled-text-color($disabled-text-color);

  @include form.set-form-field-background(transparent);

  @include expansion.set-expansion-background($background-contrast-color);

  @include missing.set-missing-selection-color($dark-gray-color-500, $warn-color-A700);

  @include slides.set-deleted-fallback($warn-color-500);
  @include slides.set-slide-background-color($text-color);
}
